<template>
  <div @click="$refs.input.focus()">
    <input @focus="initiate(); open=true;"
           @keydown.down="moveDown"
           @keydown.up="moveUp"
           @keydown.enter="choose"
           @keydown.tab.prevent="choose"
           @blur="blur"
           @input="input"
           :value="valueInInput"
           type="text"
           class="big form-control"
           :class="getValidateClass(validatename)"
           ref = "input"
           :name="validatename"
           v-validate="'required'"
           style="box-sizing: border-box" >
    <ul v-show="open" class="options-list" ref="optionsList">
      <li v-for="(option, index) in filteredOptions" :key="index" :data-id="index" @mousedown="click"
          :class="{highlighted: index === currentChoice, option: true}">{{ option }}
      </li>
    </ul>
    <validate-message
      v-show="vErrors.has(validatename)"
    >{{ vErrors.first(validatename) }}
    </validate-message>
  </div>
</template>
<script>
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  export default {
    name: 'option-selector',
    props: [
      'options',
      'validatename',
      'defaultIndex',
      'value'
    ],
    mixins: [
      GetValidateClass
    ],
    components: {
      ValidateMessage
    },
    data () {
      return {
        filteredOptions: this.options.slice(0, this.maxElements || 12),
        valueInInput: this.value,
        currentChoice: this.defaultIndex || 0,
        maxElements: this.maxElements || 12,
        open: false,
        userSelected: true
      }
    },
    methods: {
      initiate () {
        this.vErrors.clear()
        this.currentChoice = this.currentChoice || this.defaultIndex || 0
        this.updateValueInInput()
      },
      input (event) {
        this.valueInInput = event.target.value
        this.filteredOptions = this.options.filter((option) => option.search(event.target.value) !== -1).slice(0, this.maxElements)
        this.currentChoice = this.filteredOptions.length > 0 ? 0 : -1
      },
      moveDown () {
        this.currentChoice = this.currentChoice < this.filteredOptions.length - 1 ? this.currentChoice + 1 : this.currentChoice
        this.updateValueInInput()
      },
      moveUp () {
        this.currentChoice = this.currentChoice > 0 ? this.currentChoice - 1 : 0
        this.updateValueInInput()
      },
      click (event) {
        console.log(event.target)
        if (event.target.dataset.id) {
          this.currentChoice = Number(event.target.dataset.id)
          this.choose()
        }
      },
      updateValueInInput () {
        this.valueInInput = this.filteredOptions[this.currentChoice]
      },
      choose () {
        this.updateValueInInput()
        this.open = false
        this.$emit('input', this.valueInInput)
        this.userSelected = true
        this.$refs.input.blur()
      },
      blur (event) {
        if (!this.userSelected) {
          this.valueInInput = ''
          this.filteredOptions = this.options
          this.$validator.validateAll()
        }
        this.open = false
      }
    },
    watch: {
      options () {
        this.valueInInput = this.value
        this.filteredOptions = this.options.slice(0, this.maxElements || 12)
      }
    }
  }
</script>
<style scoped lang="scss">
  .margin-top_-30 {
    margin-top: 0px !important /*Fix margin -30 for this element*/
  }

  input {
    font-weight: bold;
    margin-bottom: 5px;
  }

  input:focus {
    border-radius: 5px 5px 0 0
  }

  div {
    position: relative;
    font-weight: bold;
  }

  div:after {
    content: '';
    display: block;
    position: absolute;
    top: 0;
    right: 15px;
    width: 30px;
    height: 40px;
    background: url(/lk/static/img/selector.png) 0 50% no-repeat;
  }

  .options-list {
    max-height: 500px;
    display: flex;
    flex-direction: column;
    margin-top: -6px;
    border-left: 1px solid #ffdd35;
    border-right: 1px solid #ffdd35;
    border-bottom: 1px solid #ffdd35;
    border-radius: 0 0 3px 3px;
    position: absolute;
    width: 100%;
    overflow: hidden;
    list-style: none;
    z-index: 6;
    li {
      width: 100%;
      flex-wrap: wrap;
      background: white;
      margin: 0;
      border-bottom: 1px solid #eee;
      color: #363636;
      padding: 7px;
      cursor: pointer;
    }

    li.highlighted {
      background: #f8f8f8
    }
  }
</style>
